import { Injector, TransferState } from '@angular/core';
import { AuthConfig, AuthRedirectHandler } from './interfaces/config.interface';
import { HttpClient, HttpHeaders, HttpParams } from '@angular/common/http';
import { AuthProvider, AuthSignInResponse } from './interfaces/provider.interface';
import { Storage } from '@bravobit/bb-foundation/storage';
import { HttpConfig } from '@bravobit/bb-foundation/http';
import { Observable } from 'rxjs';
import { Platform } from '@angular/cdk/platform';
import { AuthSession } from './auth.session';
import * as i0 from "@angular/core";
export declare class Auth {
    private _storage;
    private _injector;
    private _platform;
    private _httpClient;
    private _config?;
    private _state?;
    private _httpConfig?;
    private _handler?;
    private readonly _authStateKey;
    private readonly _httpAlias;
    readonly session: AuthSession;
    readonly user: Observable<any | null>;
    private _refreshHandler;
    constructor(_storage: Storage, _injector: Injector, _platform: Platform, _httpClient: HttpClient, _config?: AuthConfig, _state?: TransferState, _httpConfig?: HttpConfig, _handler?: AuthRedirectHandler);
    initialize(): () => Promise<void>;
    me<T = any>(): Observable<T>;
    signIn(provider: AuthProvider, as?: string[]): Promise<AuthSignInResponse>;
    signInWithEmail(email: string, password: string, as?: string[]): Promise<AuthSignInResponse>;
    signInWithVerifyCode(code: string, verifyToken: string): Promise<AuthSignInResponse>;
    resendVerifyCode(verifyToken: string): Promise<Object>;
    register<T = any>(data: any, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        params?: HttpParams | {
            [param: string]: string | number | boolean | ReadonlyArray<string | number | boolean>;
        };
    }): Promise<T>;
    logout(): void;
    refresh(): Observable<string>;
    requestPassword(email: string, extraParams?: {
        [key: string]: any;
    }): Promise<Object>;
    resetPassword(token: string, newPassword: string, extraParams?: {
        [key: string]: any;
    }): Promise<Object>;
    clearAndRedirect(): void;
    private setTokens;
    private handleAutoRefreshing;
    private autoRefresh;
    private get router();
    private getUrl;
    static ɵfac: i0.ɵɵFactoryDeclaration<Auth, [null, null, null, null, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Auth>;
}
