import { StorageStrategy } from '@bravobit/bb-foundation/storage';
import { AuthToken } from './interfaces/token.interface';
export declare class AuthSession {
    private readonly _jwt;
    private readonly _storage;
    private readonly _accessTokenStorageKey;
    private readonly _refreshTokenStorageKey;
    private readonly _userStorageKey;
    private _accessTokenString;
    private _refreshTokenString;
    private _accessTokenPayload;
    private _refreshTokenPayload;
    private _user$;
    user: import("rxjs").Observable<any>;
    constructor(options?: {
        id?: string;
        storage?: StorageStrategy;
    });
    get snapshot(): {
        user: any;
        accessToken: string;
        refreshToken: string;
    };
    get accessToken(): string;
    get refreshToken(): string;
    get accessTokenPayload(): AuthToken;
    get refreshTokenPayload(): AuthToken;
    authenticated(): boolean;
    setTokens(accessToken: string | null, refreshToken: string | null): void;
    setUser(user: unknown): void;
    clear(): void;
    private restoreFromStorage;
    private syncTokensInStorage;
    private syncUserInStorage;
    private setAccessToken;
    private setRefreshToken;
    private generateKey;
    private isTokenValid;
}
