import { OnDestroy, OnInit } from '@angular/core';
import { CollectionData } from '../../interfaces/collection.interface';
import { BehaviorSubject, Observable } from 'rxjs';
import { Collection } from '../../collection';
import * as i0 from "@angular/core";
export declare class BbCollectionsPager implements OnInit, OnDestroy {
    readonly maxAmountOfButtons: number;
    set label(value: string);
    set collection(collection: Collection<unknown> | null);
    data$: Observable<{
        totalPages: number;
        pageNumber: number;
        pages: {
            page: number;
            active: boolean;
        }[];
        allowNext: boolean;
        allowPrevious: boolean;
        label: string;
    }>;
    cache$: BehaviorSubject<Partial<CollectionData<unknown>>>;
    private _label;
    private _collection;
    private _subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    setPage(pageNumber: number, totalPages: number): void;
    private observeCollectionChanges;
    private calculateLabel;
    private calculatePages;
    private filterActivePages;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbCollectionsPager, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbCollectionsPager, "bb-collections-pager", never, { "label": { "alias": "label"; "required": false; }; "collection": { "alias": "collection"; "required": false; }; }, {}, never, never, false, never>;
}
