import { ChangeDetectorRef, ElementRef, OnDestroy, OnInit } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { NgControl, ValidationErrors } from '@angular/forms';
import { BbiFormControl } from './form-control/form-control.component';
import * as i0 from "@angular/core";
export declare class BbiFormControlInput implements OnInit, OnDestroy {
    private _elementRef;
    private _formControl;
    private _changeDetectorRef;
    private _ngControl;
    readonly labelId: string;
    errors: ValidationErrors | null;
    focused: boolean;
    private _subscription;
    constructor(_elementRef: ElementRef, _formControl: BbiFormControl, _changeDetectorRef: ChangeDetectorRef, _ngControl: NgControl);
    ngOnInit(): void;
    ngOnDestroy(): void;
    get control(): NgControl;
    get disabled(): boolean;
    set disabled(value: BooleanInput);
    private _disabled;
    get readonly(): boolean;
    set readonly(value: BooleanInput);
    private _readonly;
    get required(): BooleanInput;
    set required(value: BooleanInput);
    private _required;
    private handleControlErrorStatus;
    private handleControlDisabledStatus;
    private handleFocusedState;
    static ngAcceptInputType_disabled: BooleanInput;
    static ngAcceptInputType_required: BooleanInput;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbiFormControlInput, [null, null, null, { optional: true; self: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BbiFormControlInput, "input[bbiFormControlInput]", never, { "disabled": { "alias": "disabled"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "required": { "alias": "required"; "required": false; }; }, {}, never, never, false, never>;
}
