import { ChangeDetectorRef, DoCheck, EventEmitter, Injector, TemplateRef } from '@angular/core';
import { ControlValueAccessor, ValidationErrors } from '@angular/forms';
import { BbiControlErrorSubmit } from '../../control-error/control-error-submit.directive';
import { ControlErrorMode } from '../../control-error/control-error.interface';
import { BooleanInput } from '@angular/cdk/coercion';
import { BehaviorSubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class BbiRadioGroup implements DoCheck, ControlValueAccessor {
    private _injector;
    private _changeDetectorRef;
    private _errorSubmit?;
    label: string | TemplateRef<any> | null;
    errorMode: ControlErrorMode;
    valueChange: EventEmitter<any>;
    validationErrors$: BehaviorSubject<ValidationErrors>;
    get value(): any;
    set value(value: any);
    private _value;
    get disabled(): boolean;
    set disabled(value: BooleanInput);
    private _disabled;
    get grouped(): boolean;
    set grouped(value: BooleanInput);
    private _grouped;
    get readonly(): boolean;
    set readonly(value: BooleanInput);
    private _readonly;
    get required(): boolean;
    set required(value: BooleanInput);
    private _required;
    get inline(): boolean;
    set inline(value: BooleanInput);
    private _inline;
    onChange: (newValue: any) => void;
    onTouched: () => void;
    constructor(_injector: Injector, _changeDetectorRef: ChangeDetectorRef, _errorSubmit?: BbiControlErrorSubmit);
    ngDoCheck(): void;
    select(value: any): void;
    registerOnChange(fn: (newValue: boolean) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(newValue: any): void;
    static ngAcceptInputType_label: string | TemplateRef<any> | null | undefined;
    static ngAcceptInputType_value: any;
    static ngAcceptInputType_disabled: BooleanInput;
    static ngAcceptInputType_readonly: BooleanInput;
    static ngAcceptInputType_grouped: BooleanInput;
    static ngAcceptInputType_required: BooleanInput;
    static ngAcceptInputType_inline: BooleanInput;
    static ngAcceptInputType_errorMode: ControlErrorMode;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbiRadioGroup, [null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbiRadioGroup, "bbi-radio-group", never, { "label": { "alias": "label"; "required": false; }; "errorMode": { "alias": "errorMode"; "required": false; }; "value": { "alias": "value"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "grouped": { "alias": "grouped"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "required": { "alias": "required"; "required": false; }; "inline": { "alias": "inline"; "required": false; }; }, { "valueChange": "valueChange"; }, never, ["bbi-radio-button"], false, never>;
}
