import { ChangeDetectorRef, ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
export declare class BbiToggle implements ControlValueAccessor {
    private _renderer;
    private _changeDetectorRef;
    readonly labelId: string;
    inputElementRef: ElementRef<HTMLInputElement>;
    checkedChange: EventEmitter<boolean>;
    get checked(): boolean;
    set checked(value: BooleanInput);
    private _checked;
    get disabled(): boolean;
    set disabled(value: BooleanInput);
    private _disabled;
    get grouped(): boolean;
    set grouped(value: BooleanInput);
    private _grouped;
    get required(): boolean;
    set required(value: BooleanInput);
    private _required;
    get hideText(): boolean;
    set hideText(value: BooleanInput);
    private _hideText;
    onChange: (newValue: boolean) => void;
    onTouched: () => void;
    constructor(_renderer: Renderer2, _changeDetectorRef: ChangeDetectorRef);
    registerOnChange(fn: (newValue: boolean) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(newValue: boolean): void;
    toggle(): void;
    onClickEvent(event: Event): void;
    onChangeEvent(event: Event): void;
    private emitChangeEvent;
    private syncField;
    static ngAcceptInputType_checked: BooleanInput;
    static ngAcceptInputType_disabled: BooleanInput;
    static ngAcceptInputType_required: BooleanInput;
    static ngAcceptInputType_grouped: BooleanInput;
    static ngAcceptInputType_hideText: BooleanInput;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbiToggle, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbiToggle, "bbi-toggle", never, { "checked": { "alias": "checked"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "grouped": { "alias": "grouped"; "required": false; }; "required": { "alias": "required"; "required": false; }; "hideText": { "alias": "hideText"; "required": false; }; }, { "checkedChange": "checkedChange"; }, never, ["*"], false, never>;
}
