import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { AnimationEvent } from '@angular/animations';
import { DialogConfig } from '../dialog.interfaces';
import * as i0 from "@angular/core";
export declare class BbDialogOverlay implements OnInit, OnDestroy {
    private _elementRef;
    private _changeDetection;
    private _config?;
    readonly disableOverlayAnimations: boolean;
    closeRequested: EventEmitter<void>;
    state: 'open' | 'close';
    private _closed$;
    private _subscription;
    constructor(_elementRef: ElementRef, _changeDetection: ChangeDetectorRef, _config?: DialogConfig);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onKeyEvent(event: KeyboardEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    close(): Promise<void>;
    private listenForClicks;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbDialogOverlay, [null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BbDialogOverlay, "bb-dialog-overlay", never, {}, { "closeRequested": "closeRequested"; }, never, ["[bb-dialog-modal]"], false, never>;
}
