import { combineLatest, of, defer, merge } from 'rxjs';
import { map, filter, distinctUntilChanged, shareReplay } from 'rxjs/operators';

function combineLatestMap(observables) {
    const keys = Object.keys(observables);
    return combineLatest(keys.map(k => observables[k])).pipe(map(b => b.reduce((previous, value, index) => ({
        ...previous,
        [keys[index]]: value
    }), {})));
}

function filterNil() {
    return filter(value => value !== undefined && value !== null);
}

function getControlValue(control) {
    return merge(control.valueChanges, defer(() => of(control.value))).pipe(distinctUntilChanged((a, b) => a === b), shareReplay({ refCount: true, bufferSize: 1 }));
}

/**
 * Generated bundle index. Do not edit.
 */

export { combineLatestMap, filterNil, getControlValue };
//# sourceMappingURL=bravobit-bb-foundation-rxjs.mjs.map
