import { LocalizeConfig, LocalizeConfigLanguage } from './interfaces/config.interfaces';
import { LocalizeTransform } from './transforms/abstract.transform';
import { LocalizeMissingHandler } from './handlers/missing.handler';
import { LocalizeDictionary } from './dictionary/dictionary.class';
import { LocalizeParams } from './interfaces/options.interfaces';
import { Languages } from '@bravobit/bb-foundation';
import { Storage } from '@bravobit/bb-foundation/storage';
import * as i0 from "@angular/core";
export declare class Localize {
    private _storage;
    private _languages;
    private _missingHandler;
    private _config?;
    private _window?;
    private _document?;
    private _transforms?;
    private readonly _storageToken;
    private readonly _availableLanguages;
    private readonly _bestMatchingLanguage;
    private readonly _loadedDictionaries;
    private _current$;
    dictionaryChanges$: import("rxjs").Observable<LocalizeDictionary>;
    constructor(_storage: Storage, _languages: Languages, _missingHandler: LocalizeMissingHandler, _config?: LocalizeConfig, _window?: Window, _document?: Document, _transforms?: LocalizeTransform[]);
    get languages(): LocalizeConfigLanguage[];
    get current(): LocalizeDictionary;
    load(id: string): any;
    loadAllLanguages(): Promise<void>;
    switch(id: string, options?: {
        cache?: boolean;
        reload?: boolean;
    }): Promise<any>;
    select(id: string): LocalizeDictionary;
    initialize(): () => Promise<void>;
    clear(): void;
    transform(value: string, data?: LocalizeParams['data']): string;
    translate(tokenOrParams: string | LocalizeParams): string;
    private retrieveBestMatchingLanguage;
    private getLanguageFromStorage;
    private getBestBrowserMatchLanguage;
    private createDictionary;
    private getDictionary;
    private renderDocumentLanguage;
    private compareDictionaries;
    private convertToParams;
    static ɵfac: i0.ɵɵFactoryDeclaration<Localize, [null, null, null, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Localize>;
}
