import { ElementRef, NgZone, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { AbstractControl, ControlValueAccessor, NgControl, Validator } from '@angular/forms';
import { InputMaskOptions } from '../input-mask.interface';
import { Subscription } from 'rxjs';
import { Platform } from '@angular/cdk/platform';
import type Inputmask from 'inputmask';
import * as i0 from "@angular/core";
export declare class BbInputMask<T = any> implements OnInit, OnDestroy, ControlValueAccessor, Validator {
    private _ngZone;
    private _platform;
    private _renderer;
    private _elementRef;
    private _control?;
    set mask(mask: InputMaskOptions<T> | string | null | undefined);
    inputMaskPlugin: Inputmask.Instance | null;
    nativeInputElement: HTMLInputElement | null;
    eventsSubscription: Subscription | null;
    private _inputMaskOptions;
    private _onChange;
    constructor(_ngZone: NgZone, _platform: Platform, _renderer: Renderer2, _elementRef: ElementRef<HTMLInputElement>, _control?: NgControl);
    onInput: (value: any) => void;
    onTouched: () => void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    writeValue(value: string): void;
    registerOnChange(fn: (value: T | null) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    validate: (control: AbstractControl) => {
        inputMask: boolean;
    };
    private updateMask;
    private createMask;
    private destroyMask;
    static ngAcceptInputType_bbInputMask: InputMaskOptions<any> | string | null | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<BbInputMask<any>, [null, null, null, null, { optional: true; self: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BbInputMask<any>, "input[bbInputMask],input[bbCurrencyMask],input[bbDateMask]", never, { "mask": { "alias": "bbInputMask"; "required": false; }; }, {}, never, never, false, never>;
}
