import { FormControlAddonTheme } from './themes/form-control-addon.theme';
import { CheckboxGroupTheme } from './themes/checkbox-group.theme';
import { ControlErrorTheme } from './themes/control-error.theme';
import { FormControlTheme } from './themes/form-control.theme';
import { ToggleGroupTheme } from './themes/toggle-group.theme';
import { RadioButtonTheme } from './themes/radio-button.theme';
import { RadioGroupTheme } from './themes/radio-group.theme';
import { CheckboxTheme } from './themes/checkbox.theme';
import { ToggleTheme } from './themes/toggle.theme';
export type ThemeDataRecord = Record<string, string> | string;
export type ColorString = `#${string}`;
export interface GlobalTheme {
    accentColor: ColorString;
    errorColor: ColorString;
    formControl: FormControlTheme;
    formControlAddon: FormControlAddonTheme;
    checkbox: CheckboxTheme;
    checkboxGroup: CheckboxGroupTheme;
    radioButton: RadioButtonTheme;
    radioGroup: RadioGroupTheme;
    toggle: ToggleTheme;
    toggleGroup: ToggleGroupTheme;
    controlError: ControlErrorTheme;
    custom?: {
        [key: string]: ThemeDataRecord;
    };
}
type Subset<K> = {
    [attr in keyof K]?: K[attr] extends object ? Subset<K[attr]> : K[attr];
};
export type PartialGlobalTheme = Subset<GlobalTheme>;
export type GlobalVariables = Pick<GlobalTheme, 'accentColor' | 'errorColor'>;
export type GlobalVariablesKey = keyof GlobalVariables;
export {};
